#ifndef HWCORE_INCLUDED
#define HWCORE_INCLUDED



#ifndef TYPES_INCLUDED
    #error "Needs types(Types.inc)."
    //#include "Types.inc"
#endif

#ifdef ROBDEBUG_INCLUDED
    #error "Must include hardware core(HWCore.inc) before robust debugging(RobDebug.inc)."
#endif

//INSW - input string of words
void insw(U16 Port, U16 *Buf, I16 Count)
{
    _ES = FP_SEG(Buf);   // Segment of Buf
    _DI = FP_OFF(Buf);   // Offset of Buf
    _CX = Count;         // Number to read
    _DX = Port;          // Port
    asm   REP INSW;
}

//INSDW - input string of dwords
void insdw(U16 Port, U32 *Buf, I16 Count)
{
    _ES = FP_SEG(Buf);   // Segment of Buf
    _DI = FP_OFF(Buf);   // Offset of Buf
    _CX = Count;         // Number to read
    _DX = Port;          // Port
    asm   REP INSD;
}

U32 InPortDW(U16 Port)
{
    asm {
        mov     dx,[Port]
        in      eax,dx
    }

    return _EAX;
}

void OutPortDW(U16 Port, U32 Value)
{
    asm {
        mov     dx,[Port]
        mov     eax,[Value]
        out     dx,eax
    }
}

U8 DebugInPortB(U16 Addr)
{
    if ( Addr >= 0x400 )
        return inportb(Addr);
    else
        return 0xA5
    ;
}

U16 DebugInPort(U16 Addr)
{
    if ( Addr >= 0x400 )
        return inport(Addr);
    else
        return 0xA5A5
    ;
}

U32 DebugInPortDW(U16 Addr)
{
    if ( Addr >= 0x400 )
        return InPortDW(Addr);
    else
        return 0xA5A5A5A5
    ;
}

U16 DebugINSW(U16 Addr)
{
    if ( Addr >= 0x400 )
        return inport(Addr);
    else
        return 0xA5A5
    ;
}

U32 DebugINSDW(U16 Addr)
{
    if ( Addr >= 0x400 )
        return InPortDW(Addr);
    else
        return 0xA5A5A5A5
    ;
}

TStatus DebugOutPortB(U16 Addr, U8 Data)
{
    if ( Addr >= 0x400 )
    {
        outportb(Addr, Data);
        return StatusOK;
    }
    else
        return StatusNoHardware
    ;
}

TStatus DebugOutPort(U16 Addr, U16 Data)
{
    if ( Addr >= 0x400 )
    {
        outport(Addr, Data);
        return StatusOK;
    }
    else
        return StatusNoHardware
    ;
}

TStatus DebugOutPortDW(U16 Addr, U32 Data)
{
    if ( Addr >= 0x400 )
    {
        OutPortDW(Addr, Data);
        return StatusOK;
    }
    else
        return StatusNoHardware
    ;
}



#endif